//
// Copyright (c) 1999 by Dmitry Morozhnikov
//
#include <stdio.h>
#include <WINGs.h>
#include <WINGsP.h>
#include <WUtil.h>
#include <unistd.h>
/*#include <sys/param.h>*/
#include <X11/keysym.h>
#include <X11/X.h>
#include <X11/Xlib.h>

void
wAbort()
{
   exit(1);
};

char errstr[256];

int 
execCommand(char *command)
{
/*    pid_t pid;*/
/*    char tempbuff[MAXPATHLEN];*/
/*
    if((pid=fork())==-1)
    {
	strcpy(errstr,"Can`t fork");
	return -1;
    };
*/
/*    if(!realpath(command,tempbuff))*/
    char commname[256];
    strncpy(commname,command,255);
    strtok(commname," ");
    if(!wfindfile(getenv("PATH"),commname))
    {
	strcpy(errstr,"Can`t find file");
/*	perror("");*/
	return -1;
    };
/*    printf("%s\n",command);*/
    execl("/bin/sh","sh","-c",command,NULL);
/*    execlp(command,NULL);*/
    strcpy(errstr,"Can`t execute command");
    return -1;
};

Display *dpy;
int inxterm=0;
WMScreen *scr;
WMWindow *win;
WMTextField *tfl;
WMButton *btn;
WMButton *bok;
WMButton *bcns;
WMPoint *pos;
WMUserDefaults *udef;

void
saveData()
{
/*    *pos=WMGetViewPosition(W_VIEW(win));*/
    WMView *winview;
    XWindowAttributes *wattr;
    Window ownwin;
    Window twin;
    Window *ttwin;
    unsigned int tint;
    winview=W_VIEW(win);
/*    winview=winview->parent;*/
/*
    pos->x=winview->pos.x;
    pos->y=winview->pos.y;
    printf("%i %i\n",pos->x,pos->y);
*/
    XQueryTree(dpy,winview->window,&twin,&ownwin,&ttwin,&tint);
    XGetWindowAttributes(dpy,ownwin,wattr);
/*    printf("%i %i %i %i\n",wattr->x,wattr->y,winview->window,ownwin);*/
/*    *pos=WMGetViewPosition(winview);*/
    WMSetUDIntegerForKey(udef,wattr->x,"xpos");
    WMSetUDIntegerForKey(udef,wattr->y,"ypos");
};

void
closeaction(WMWidget *self,void *clientData)
{
    saveData();
    exit(0);
};

void
btnaction(WMWidget *self,void *clientData)
{
    if(inxterm)
    {
	inxterm=0;
    }
    else
    {
	inxterm=1;
    };
};

void
bpush(WMWidget *self,void *clientData)
{
    if(clientData)
    {
	char *comm;
	char msg[1024];
	char *xterm="xterm -e";
	comm=WMGetTextFieldText(tfl);
	if(inxterm)
	{
	    char *xtermedcomm=wmalloc(strlen(xterm)+strlen(comm)+4);
	    strcpy(xtermedcomm,xterm);
	    strcat(xtermedcomm," ");
	    strcat(xtermedcomm,comm);
	    saveData();
	    execCommand(xtermedcomm);
	    strcpy(msg,"Error found while starting command:\n");
	    strcat(msg,comm);
	    strcat(msg,"\nin terminal\n");
	    strcat(msg,errstr);
	}
	else
	{
	    saveData();
	    execCommand(comm);
	    strcpy(msg,"Error found while starting command:\n");
	    strcat(msg,comm);
	    strcat(msg,"\n");
	    strcat(msg,errstr);
	};
	WMRunAlertPanel(scr,win,"Error",msg,"Close",NULL,NULL);
	exit(0);
    }
    else
    {
	saveData();
	exit(0);
    };
};

void
handleKeyPress(XEvent *event,void *clientData)
{
    if(event->xkey.keycode==XKeysymToKeycode(dpy,XK_Return))
    {
	WMPerformButtonClick(bok);
    };
    if(event->xkey.keycode==XKeysymToKeycode(dpy,XK_Escape))
    {
	WMPerformButtonClick(bcns);
    };
};

main(int argc,char **argv)
{
    WMPixmap *apppxm;
    char *apppath;

    WMInitializeApplication("WMLauncher",&argc,argv);
    if(!(dpy=XOpenDisplay("")))
    {
	exit(1);
    };
    scr=WMCreateScreen(dpy,DefaultScreen(dpy));
    win=WMCreateWindowWithStyle(scr,"WMLauncher",
	WMTitledWindowMask|WMClosableWindowMask);
    WMSetWindowCloseAction(win,closeaction,NULL);
    WMSetWindowTitle(win,"WMLauncher");
    WMResizeWidget(win,300,100);
    btn=WMCreateSwitchButton(win);
    WMSetButtonText(btn,"Run in terminal");
    WMSetButtonAction(btn,btnaction,NULL);
    WMResizeWidget(btn,120,30);
    WMMoveWidget(btn,290-WMWidgetWidth(btn),5);
    tfl=WMCreateTextField(win);
    WMMoveWidget(tfl,5,40);
    WMResizeWidget(tfl,290,20);
    bok=WMCreateCommandButton(win);
    WMSetButtonAction(bok,bpush,(void *)1);
    WMSetButtonText(bok,"Run");
    WMSetButtonImage(bok,WMGetSystemPixmap(scr,WSIReturnArrow));
    WMSetButtonAltImage(bok,WMGetSystemPixmap(scr,WSIHighlightedReturnArrow));
    WMSetButtonImagePosition(bok,WIPRight);
    WMResizeWidget(bok,80,25);
    WMMoveWidget(bok,215,70);
    bcns=WMCreateCommandButton(win);
    WMSetButtonText(bcns,"Cancel");
    WMSetButtonAction(bcns,bpush,NULL);
    WMResizeWidget(bcns,80,25);
    WMMoveWidget(bcns,130,70);

    WMCreateEventHandler(W_VIEW(win),KeyPressMask,
	handleKeyPress,NULL);
    WMCreateEventHandler(W_VIEW(tfl),KeyPressMask,
	handleKeyPress,NULL);
    WMSetFocusToWidget(tfl);
    
    apppath=WMPathForResourceOfType("wmlaunch.tiff",NULL);
    if(!apppath && !(apppath=wfindfile(".","wmlaunch.tiff")))
    {
	wwarning("Can`t find application icon wmlaunch.tiff");
    }
    else
    {
	if(apppxm=WMCreatePixmapFromFile(scr,apppath))
	{
	    WMSetApplicationIconImage(scr,apppxm);
	};
    };
    
    udef=WMGetStandardUserDefaults();
    pos=wmalloc(sizeof(WMPoint));
    pos->x=WMGetUDIntegerForKey(udef,"xpos");
    pos->y=WMGetUDIntegerForKey(udef,"ypos");

    WMRealizeWidget(win);
    WMMapSubwidgets(win);
    WMMapWidget(win);
    
    WMMoveWidget(win,pos->x,pos->y);
    
    WMScreenMainLoop(scr);
};
